// @TODO: this guy has a similar project, with the same problem
// https://github.com/andreiduca/cra-ssr-code-splitting/issues/7
// (seems solved with "chunks:initial")

import { ReactLoadablePlugin } from  'react-loadable/webpack'

export const webpackReactLoadable = (config, settings = {}) => {
    config.plugins = [
        ...config.plugins,
        new ReactLoadablePlugin({
            filename: settings.target || './build/react-loadable.json',
        }),
    ]
    
    // "chunks:all" generates some unpredictable chunks based on "node_modules"
    // that are not detected by "react-loadable", hence will cause some flickering
    // in the rendering because the chunk itself is not going to be places into
    // the initial HTML rendering.
    config.optimization = {
        ...config.optimization,
        splitChunks: { chunks: 'initial' },
    }

    return config
}
